# mypy-boto3-autoscaling-plans

[![PyPI - mypy-boto3-autoscaling-plans](https://img.shields.io/pypi/v/mypy-boto3-autoscaling-plans.svg?color=blue)](https://pypi.org/project/mypy-boto3-autoscaling-plans)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-autoscaling-plans.svg?color=blue)](https://pypi.org/project/mypy-boto3-autoscaling-plans)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-autoscaling-plans?color=blue)](https://pypistats.org/packages/mypy-boto3-autoscaling-plans)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.AutoScalingPlans 1.17.64](https://boto3.amazonaws.com/v1/documentation/api/1.17.64/reference/services/autoscaling-plans.html#AutoScalingPlans) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 4.8.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[auto-generated docs](https://github.com/vemel/mypy_boto3_builder/service_docs/mypy_boto3_autoscaling_plans/README.md)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-autoscaling-plans](#mypy-boto3-autoscaling-plans)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)

## How to install

Install `boto3-stubs` for `AutoScalingPlans` service.

```bash
python -m pip install boto3-stubs[autoscaling-plans]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[autoscaling-plans]` in your environment: `python -m pip install 'boto3-stubs[autoscaling-plans]'`

Both type checking and auto-complete should work for `AutoScalingPlans` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[autoscaling-plans]` in your environment: `python -m pip install 'boto3-stubs[autoscaling-plans]'`

Both type checking and auto-complete should work for `AutoScalingPlans` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[autoscaling-plans]` in your environment: `python -m pip install 'boto3-stubs[autoscaling-plans]'`
- Run `mypy` as usual

Type checking should work for `AutoScalingPlans` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[autoscaling-plans]` in your environment: `python -m pip install 'boto3-stubs[autoscaling-plans]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `AutoScalingPlans` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`AutoScalingPlansClient` provides annotations for `boto3.client("autoscaling-plans")`.

```python
import boto3

from mypy_boto3_autoscaling_plans import AutoScalingPlansClient

client: AutoScalingPlansClient = boto3.client("autoscaling-plans")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: AutoScalingPlansClient = session.client("autoscaling-plans")
```

### Paginators annotations

`mypy_boto3_autoscaling_plans.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_autoscaling_plans import AutoScalingPlansClient
from mypy_boto3_autoscaling_plans.paginator import (
    DescribeScalingPlanResourcesPaginator,
    DescribeScalingPlansPaginator,
)

client: AutoScalingPlansClient = boto3.client("autoscaling-plans")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
describe_scaling_plan_resources_paginator: DescribeScalingPlanResourcesPaginator = client.get_paginator("describe_scaling_plan_resources")
describe_scaling_plans_paginator: DescribeScalingPlansPaginator = client.get_paginator("describe_scaling_plans")
```







### Literals

`mypy_boto3_autoscaling_plans.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from mypy_boto3_autoscaling_plans.literals import (
    DescribeScalingPlanResourcesPaginatorName,
    DescribeScalingPlansPaginatorName,
    ForecastDataType,
    LoadMetricType,
    MetricStatistic,
    PolicyType,
    PredictiveScalingMaxCapacityBehavior,
    PredictiveScalingMode,
    ScalableDimension,
    ScalingMetricType,
    ScalingPlanStatusCode,
    ScalingPolicyUpdateBehavior,
    ScalingStatusCode,
    ServiceNamespace,
)

def check_value(value: DescribeScalingPlanResourcesPaginatorName) -> bool:
    ...
```



### Typed dictionaries

`mypy_boto3_autoscaling_plans.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_autoscaling_plans.type_defs import (
    ApplicationSourceTypeDef,
    CreateScalingPlanResponseTypeDef,
    CustomizedLoadMetricSpecificationTypeDef,
    CustomizedScalingMetricSpecificationTypeDef,
    DatapointTypeDef,
    DescribeScalingPlanResourcesResponseTypeDef,
    DescribeScalingPlansResponseTypeDef,
    GetScalingPlanResourceForecastDataResponseTypeDef,
    MetricDimensionTypeDef,
    PaginatorConfigTypeDef,
    PredefinedLoadMetricSpecificationTypeDef,
    PredefinedScalingMetricSpecificationTypeDef,
    ScalingInstructionTypeDef,
    ScalingPlanResourceTypeDef,
    ScalingPlanTypeDef,
    ScalingPolicyTypeDef,
    TagFilterTypeDef,
    TargetTrackingConfigurationTypeDef,
)

def get_structure() -> ApplicationSourceTypeDef:
    return {
      ...
    }
```
